## libpog 0.5.3

=== docs/requirements.txt ===
Sphinx==2.1.2
sphinx_rtd_theme==0.4.3

=== examples/CMakeLists.txt ===
add_subdirectory(calculator)
add_subdirectory(ini)

=== tests/CMakeLists.txt ===
add_subdirectory(googletest)

set(TEST_FILES
	pog_tests.cpp
	test_automaton.cpp
	test_filter_view.cpp
	test_grammar.cpp
	test_item.cpp
	test_parser.cpp
	test_parsing_table.cpp
	test_precedence.cpp
	test_rule.cpp
	test_rule_builder.cpp
	test_state.cpp
	test_symbol.cpp
	test_token.cpp
	test_tokenizer.cpp
	test_token_builder.cpp
	test_utils.cpp
)

add_executable(pog_tests ${TEST_FILES})
if (MSVC)
	# This flag is needed for MSVC because test_parser.cpp exceeds limit of number of section in Debug x64 build
	set_source_files_properties(test_parser.cpp PROPERTIES COMPILE_FLAGS /bigobj)
endif()
target_link_libraries(pog_tests pog googletest)

=== deps/fmt/CMakeLists.txt ===
include(GNUInstallDirs)
include(ExternalProject)

set(FMT_INSTALL_DIR             ${CMAKE_CURRENT_BINARY_DIR}/fmt)
set(FMT_INCLUDE_DIR             ${FMT_INSTALL_DIR}/include)
set(FMT_INSTALLED_LIBRARY       ${FMT_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}fmt${CMAKE_STATIC_LIBRARY_SUFFIX})
set(FMT_INSTALLED_LIBRARY_DEBUG ${FMT_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}fmtd${CMAKE_STATIC_LIBRARY_SUFFIX})
set(FMT_LIBRARY                 ${FMT_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}pog_fmt${CMAKE_STATIC_LIBRARY_SUFFIX})

if(MSVC)
	set(FMT_BUILD_COMMAND ${CMAKE_COMMAND} --build . --config $<CONFIG> -- -m)
	set(FMT_INSTALL_COMMAND ${CMAKE_COMMAND} --build . --target install --config $<CONFIG>)
else()
	set(FMT_BUILD_COMMAND ${CMAKE_COMMAND} --build . -- -j)
	set(FMT_INSTALL_COMMAND ${CMAKE_COMMAND} --build . --target install)
endif()

ExternalProject_Add(
	fmt-dep
	PREFIX "fmt"
	SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/fmt"
	CMAKE_ARGS
		-DCMAKE_INSTALL_PREFIX=${FMT_INSTALL_DIR}
		-DCMAKE_BUILD_TYPE=Release
		-DCMAKE_POSITION_INDEPENDENT_CODE=${POG_PIC}
		-DFMT_TEST=OFF
		-DFMT_DOC=OFF
	BUILD_COMMAND
		${FMT_BUILD_COMMAND}
	INSTALL_COMMAND
		${FMT_INSTALL_COMMAND}
)

ExternalProject_Add_Step(
	fmt-dep rename
	DEPENDEES install
	COMMAND ${CMAKE_COMMAND} -E rename $<IF:$<CONFIG:Debug>,${FMT_INSTALLED_LIBRARY_DEBUG},${FMT_INSTALLED_LIBRARY}> ${FMT_LIBRARY}
)

add_library(fmt::fmt STATIC IMPORTED GLOBAL)
set_target_properties(fmt::fmt PROPERTIES
	INTERFACE_INCLUDE_DIRECTORIES "${FMT_INCLUDE_DIR}"
	IMPORTED_LOCATION "${FMT_LIBRARY}"
)
add_dependencies(fmt::fmt fmt-dep)

install(
	FILES ${FMT_LIBRARY}
	DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}
)
install(
	DIRECTORY ${FMT_INCLUDE_DIR}/fmt/
	DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}/pog/fmt
)

=== deps/re2/CMakeLists.txt ===
include(ExternalProject)

include(GNUInstallDirs)

set(RE2_INSTALL_DIR       ${CMAKE_CURRENT_BINARY_DIR}/re2)
set(RE2_INCLUDE_DIR       ${RE2_INSTALL_DIR}/include)
set(RE2_INSTALLED_LIBRARY ${RE2_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}re2${CMAKE_STATIC_LIBRARY_SUFFIX})
set(RE2_LIBRARY           ${RE2_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}pog_re2${CMAKE_STATIC_LIBRARY_SUFFIX})

if(MSVC)
	set(RE2_BUILD_COMMAND ${CMAKE_COMMAND} --build . --config $<CONFIG> -- -m)
	set(RE2_INSTALL_COMMAND ${CMAKE_COMMAND} --build . --target install --config $<CONFIG>)
else()
	set(RE2_BUILD_COMMAND ${CMAKE_COMMAND} --build . -- -j)
	set(RE2_INSTALL_COMMAND ${CMAKE_COMMAND} --build . --target install)
endif()

ExternalProject_Add(
	re2-dep
	PREFIX "re2"
	SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/re2"
	CMAKE_ARGS
		-DCMAKE_INSTALL_PREFIX=${RE2_INSTALL_DIR}
		-DCMAKE_POSITION_INDEPENDENT_CODE=${POG_PIC}
		-DCMAKE_BUILD_TYPE=Release
		-DRE2_BUILD_TESTING=OFF
	BUILD_COMMAND
		${RE2_BUILD_COMMAND}
	INSTALL_COMMAND
		${RE2_INSTALL_COMMAND}
)

ExternalProject_Add_Step(
	re2-dep rename
	DEPENDEES install
	COMMAND ${CMAKE_COMMAND} -E rename ${RE2_INSTALLED_LIBRARY} ${RE2_LIBRARY}
)

add_library(re2::re2 STATIC IMPORTED GLOBAL)
set_target_properties(re2::re2 PROPERTIES
	INTERFACE_INCLUDE_DIRECTORIES "${RE2_INCLUDE_DIR}"
	IMPORTED_LOCATION "${RE2_LIBRARY}"
)
target_link_libraries(re2::re2 INTERFACE Threads::Threads)
add_dependencies(re2::re2 re2-dep)

install(
	FILES ${RE2_LIBRARY}
	DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}
)
install(
	DIRECTORY ${RE2_INCLUDE_DIR}/re2/
	DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}/pog/re2
)

=== examples/calculator/CMakeLists.txt ===
add_executable(example-calculator calculator.cpp)
target_link_libraries(example-calculator pog)

=== examples/ini/CMakeLists.txt ===
add_executable(example-ini ini.cpp)
target_link_libraries(example-ini pog)

=== tests/googletest/CMakeLists.txt ===
add_library(googletest STATIC gmock-gtest-all.cc)
target_include_directories(googletest PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(googletest Threads::Threads)

=== debian/changelog ===
libpog (0.5.3-3) unstable; urgency=medium

  * Ignore bitness check in CMake config file

 -- Yangfl <mmyangfl@gmail.com>  Mon, 20 Jul 2020 08:43:36 +0800

libpog (0.5.3-2) unstable; urgency=medium

  * Bump debhelper compat to 13

 -- Yangfl <mmyangfl@gmail.com>  Thu, 25 Jun 2020 12:33:05 +0800

libpog (0.5.3-1) unstable; urgency=medium

  * Initial release

 -- Yangfl <mmyangfl@gmail.com>  Wed, 15 Apr 2020 15:07:50 +0800

=== debian/control ===
Source: libpog
Section: libs
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 pkg-config,
 libre2-dev,
 libfmt-dev,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/metthal/pog
Vcs-Git: https://salsa.debian.org/yangfl-guest/pog.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/pog

Package: libpog-dev
Section: libdevel
Architecture: all
Depends:
 libre2-dev,
 libfmt-dev,
 ${misc:Depends},
Description: C++ library for generating LALR(1) parsers
 Pog is C++17 library for generating LALR(1) parsers. This library is
 header-only itself but requires RE2 library which does not come with
 header-only version. It splits definitions of parser into:
  * Declaration of tokens (regular expressions describing how the input should
    be tokenized)
  * Grammar rules over tokens from tokenization phase

=== debian/tests/control ===
Tests: unittest.sh
Depends: @builddeps@, libpog-dev,

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libpog-$1.tar.gz%" \
   https://github.com/metthal/pog/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
